version: '2'
services:

  awx-web:
    image: {{ awx_image_url }}
    container_name: awx-web
    depends_on:
      - redis
    command: /usr/bin/launch_awx.sh
    hostname: "{{ awx_cluster_node_host_id }}"
    restart: unless-stopped
    network_mode: host
    volumes:
      - "{{ awx_directory }}/supervisor-socket:/var/run/supervisor:rw"
      - "{{ awx_directory }}/rsyslog-socket:/var/run/awx-rsyslog:rw"
      - "{{ awx_directory }}/rsyslog-config:/var/lib/awx/rsyslog:rw"
      - "{{ awx_directory }}/execution_environments.py:/etc/tower/conf.d/execution_environments.py:ro"
      - "{{ awx_directory }}/launch_awx.sh:/usr/bin/launch_awx.sh:ro"
      - "{{ awx_directory }}/tls/work-public-key.pem:/etc/receptor/signing/work-public-key.pem:ro"
      - "{{ awx_directory }}/tls/receptor-ca.crt:/etc/receptor/tls/ca/receptor-ca.crt:ro"
      - "{{ awx_directory }}/tls/receptor-ca.key:/etc/receptor/tls/ca/receptor-ca.key:ro"
      - "{{ awx_directory }}/credentials.py:/etc/tower/conf.d/credentials.py:ro"
      - "{{ awx_directory }}/SECRET_KEY:/etc/tower/SECRET_KEY:ro"
      - "{{ awx_directory }}/settings.py:/etc/tower/settings.py:ro"
      - "{{ awx_directory }}/awx-nginx.conf:/etc/nginx/nginx.conf:ro"
      - "{{ awx_directory }}/redis_socket:/var/run/redis/:rw"
      - "{{ awx_directory }}/projects:/var/lib/awx/projects:rw"
    environment:
      UWSGI_MOUNT_PATH: '/'

  awx-task:
    image: {{ awx_image_url }}
    container_name: awx-task
    depends_on:
      - awx-web
      - awx-ee
    command: /usr/bin/launch_awx_task.sh
    hostname: "{{ awx_cluster_node_host_id }}"
    restart: unless-stopped
    network_mode: host
    volumes:
      - "{{ awx_directory }}/supervisor-socket:/var/run/supervisor:rw"
      - "{{ awx_directory }}/rsyslog-socket:/var/run/awx-rsyslog:rw"
      - "{{ awx_directory }}/rsyslog-config:/var/lib/awx/rsyslog:rw"
      - "{{ awx_directory }}/receptor_socket:/var/run/receptor:rw"
      - "{{ awx_directory }}/execution_environments.py:/etc/tower/conf.d/execution_environments.py:ro"
      - "{{ awx_directory }}/tls/work-private-key.pem:/etc/receptor/signing/work-private-key.pem:ro"
      - "{{ awx_directory }}/SECRET_KEY:/etc/tower/SECRET_KEY:ro"
      - "{{ awx_directory }}/launch_awx_task.sh:/usr/bin/launch_awx_task.sh:ro"
      - "{{ awx_directory }}/settings.py:/etc/tower/settings.py:ro"
      - "{{ awx_directory }}/credentials.py:/etc/tower/conf.d/credentials.py:ro"
{% if awx_cluster_node_type == 'primary' %}
# :TODO: is this needed ?
      - "{{ awx_directory }}/environment.sh:/etc/tower/conf.d/environment.sh:ro"
{% endif %}
      - "{{ awx_directory }}/redis_socket:/var/run/redis/:rw"
      - "{{ awx_directory }}/projects:/var/lib/awx/projects:rw"
      - "{{ awx_directory }}/receptor:/etc/receptor/:rw"
    environment:
      SUPERVISOR_WEB_CONFIG_PATH: '/etc/supervisord.conf'

  awx-ee:
    image: {{ awx_ee_image_url }}
    container_name: awx-ee
    privileged: true
    command: ["/bin/sh", "/receptor.sh"]
    hostname: "{{ awx_cluster_node_host_id }}"
    restart: unless-stopped
    network_mode: host
    volumes:
      - "{{ awx_directory }}/receptor_socket:/var/run/receptor/:rw"
      - "{{ awx_directory }}/projects:/var/lib/awx/projects:rw"
      - "{{ awx_directory }}/receptor:/etc/receptor/:rw"
      - "{{ awx_directory }}/containers:/home/runner/.local/share/containers/:rw"
      - "{{ awx_directory }}/receptor.sh:/receptor.sh:ro"
      - "{{ awx_directory }}/tls/receptor-ca.crt:/etc/receptor/tls/ca/receptor-ca.crt:ro"
      - "{{ awx_directory }}/receptor-default.conf:/etc/receptor/receptor-default.conf:ro"
      - "{{ awx_directory }}/tls/work-private-key.pem:/etc/receptor/signing/work-private-key.pem:ro"
      - "{{ awx_directory }}/tls/{{ inventory_hostname }}.crt:/etc/receptor/tls/receptor.crt:ro"
      - "{{ awx_directory }}/tls/{{ inventory_hostname }}.key:/etc/receptor/tls/receptor.key:ro"

  redis:
    image: redis:{{ awx_redis_version }}
    container_name: redis
    restart: unless-stopped
    command: ["/usr/local/etc/redis/redis.conf"]
    volumes:
      - "{{ awx_directory }}/redis.conf:/usr/local/etc/redis/redis.conf:ro"
      - "{{ awx_directory }}/redis_socket:/var/run/redis/:rw"
    network_mode: host

